Package: unbalanced
Type: Package
Title: Racing for Unbalanced Methods Selection
Version: 2.0
Date: 2015-06-25
Author: Andrea Dal Pozzolo, Olivier Caelen and Gianluca Bontempi
Maintainer: Andrea Dal Pozzolo <adalpozz@ulb.ac.be>
Description: A dataset is said to be unbalanced when the class of interest (minority class) is much rarer than normal behaviour (majority class). The cost of missing a minority class is typically much higher that missing a majority class. Most learning systems are not prepared to cope with unbalanced data and several techniques have been proposed. This package implements some of most well-known techniques and propose a racing algorithm to select adaptively the most appropriate strategy for a given unbalanced task.
License: GPL (>= 3)
URL: http://mlg.ulb.ac.be
Depends: mlr, foreach, doParallel
Imports: FNN, RANN
Suggests: randomForest, ROCR
Packaged: 2015-06-26 09:54:30 UTC; Andrea
NeedsCompilation: no
Repository: CRAN
Date/Publication: 2015-06-26 13:34:37

ubSMOTE <-
function(X,Y,perc.over=200,k=5,perc.under=200,verbose=TRUE){
  
  if(!is.factor(Y)) 
    stop("Y has to be a factor")
  if(is.vector(X)) 
    stop("X cannot be a vector")  
  
  data<-cbind(X,Y)
  id.1 <- which(Y == 1)
  
  time<-system.time({
    # generate synthetic cases from these id.1
    newExs <- ubSmoteExs(data[id.1,],"Y",perc.over,k)   
  })
#   if(verbose)
#     cat("Time SMOTE:",round(as.numeric(time["elapsed"]),digits=2),"; perc.over",perc.over,"; perc.under",perc.under,"; k",k,"\n")
  
  row.has.na<-function(X)
    return(apply(X,1,function(x){any(is.na(x))}))
  
  row.is.na<-row.has.na(newExs)
  
  if(any(row.is.na)) {
    newExs<-newExs[!row.is.na, ]
    colnames(newExs)<-colnames(data)
    cat("WARNING: NAs generated by SMOTE removed \n")
  }
  
  # get the undersample of the "majority class" examples
  selMaj <- sample((1:NROW(data))[-id.1],
                   as.integer((perc.under/100)*nrow(newExs)),
                   replace=T)
  
  # the final data set (the undersample + the rare cases + the smoted exs)
  newdataset <- rbind(data[selMaj,],data[id.1,],newExs)
  #shuffle the order of instances
  newdataset<-newdataset[sample(1:NROW(newdataset)), ]
  
  X<-newdataset[ ,-ncol(newdataset)]
  Y<-newdataset[ ,ncol(newdataset)]
  
  return(list(X=X,Y=Y))
}

ubOSS <-
function(X, Y, verbose=TRUE){
  
  stopifnot(class(verbose) == "logical", all(unique(Y) %in% c(0, 1)))
  
  #only numeric features are allowed
  if(any(sapply(X,is.numeric)==FALSE))
    stop("only numeric features are allowed to compute nearest neighbors")
  
  S.X<-X
  S.Y<-Y
  i.1<-which(Y==1)
  N.1<-length(i.1)
  i.0<-which(Y==0)
  N.0<-length(i.0)
  if(N.1==0 | N.0==0) {
    cat("all instances of the same class \n")
    return(list(X=X,Y=Y))
  }
  
  #initially C contains all 1s from S and one random 0 obs
  id.C<-c(i.1,sample(i.0,1))	
  C.X<-X[id.C, ]
  C.Y<-Y[id.C]
  #use C to to build a 1-NN and classify all obs in S
  Y.knn<-knn(C.X, S.X, C.Y, k = 1)
  #move missclassified obs into C
  id.miss<-which(S.Y!=Y.knn)
  id.C<-c(id.C,id.miss)
  id.C <- sort(id.C)
  #id.C<-sample(id.C)
  C.X<-X[id.C, ]
  C.Y<-Y[id.C]
  #now C is consistent with S
  
  #remove from C 0s that are tomek links
  data<-ubTomek(C.X, C.Y, verbose)
  X<-data$X
  Y<-data$Y
  
  return(list(X=X,Y=Y))
}

ubENN <-
function(X,Y, k=3, verbose=TRUE){
  
  stopifnot(k > 0, class(verbose) == "logical", all(unique(Y) %in% c(0, 1)))
  
  #only numeric features are allowed
  if(any(sapply(X,is.numeric)==FALSE))
    stop("only numeric features are allowed to compute nearest neighbors")
  
  i.1<-which(Y==1)
  i.0<-which(Y==0)
  
  if(length(i.0)==0){
    #if there are no 0 obs then don't do anything
    if(verbose) 
      cat("Warning: No negative instances \n")
    return(list(X=X,Y=Y))
  }
  
  #removes only example from the majority class
  timeRemove<-system.time({
    out.hat <- FNN::knn(train=X,test=X[i.0,], cl=Y, k=k+1,prob=TRUE) #the 1-nn is the point itself therefore we need k+1
    proba.hat <- attr(out.hat, "prob")
    levels(out.hat) <- c(0,1)
    prob.th <- k/(k+1)
    id.miss <- which((Y[i.0]!=out.hat) & (proba.hat>=prob.th))
  })	 
  if(verbose) 
    cat("Number of instances removed from majority class with ENN:",length(id.miss),
        "\t Time needed:",round(as.numeric(timeRemove["elapsed"]),digits=2),"\n")
  
  if(length(id.miss)==0) 
    id.keep.0<-i.0
  else 
    id.keep.0<-setdiff(i.0,i.0[id.miss])
  
  Id<-c(id.keep.0,i.1)
  Id<-sort(Id)
  id.removed<-setdiff(1:nrow(X),Id)
  
  if (is.vector(X)!=TRUE) X=X[Id,]
  else  X=X[Id]
  Y=Y[Id]
  
  return(list(X=X,Y=Y,id.rm=id.removed))
}

ubBalance <-
function(X, Y, type = "ubSMOTE", positive = 1, 
                      percOver = 200, percUnder = 200, k = 5, 
                      perc = 50, method = "percPos", w = NULL, 
                      verbose = FALSE) {
  
  if (any(is.na(Y))) 
    stop("Y has NAs")
  
  if (!is.factor(Y)) 
    stop("Y must be a factor")
  
  lev <- levels(Y)
  if (length(lev) != 2) 
    stop("Y must be a binary factor variable")
  
  # transform the output in the range {0, 1}
  Y <- factor(Y == positive, levels = c(FALSE, TRUE), labels = c(0, 1))
  
  
  if (length(type) > 1) 
    stop("balance type does not support multiple selection")
  
  N.0 <- length(which(Y == 0))
  N.1 <- length(which(Y == 1))
  if (N.0 == 0) {
    cat("Warning: No negative instances, skip balance \n")
    return(list(X = X, Y = Y))
  }
  
  if (N.1 == 0) {
    cat("Warning: No positive instances, skip balance \n")
    return(list(X = X, Y = Y))
  }
  
  if (N.0 == N.1) {
    cat("Warning: equal number of positives and negatives, skip balance \n")
    return(list(X = X, Y = Y))
  }
  
  if (N.0 < N.1) 
    stop(positive, " class is not the minority class")
  
  data <- NULL
  
  if (type == "ubOver") 			data <- ubOver(X, Y, k, verbose)
  if (type == "ubUnder") 	    data <- ubUnder(X, Y, perc, method, w)
  if (type == "ubSMOTE") 	    data <- ubSMOTE(X, Y, percOver, k, percUnder, verbose)
  if (type == "ubOSS") 	      data <- ubOSS(X, Y, verbose)
  if (type == "ubCNN") 	      data <- ubCNN(X, Y, k, verbose)
  if (type == "ubENN") 	      data <- ubENN(X, Y, k, verbose)
  if (type == "ubNCL") 	      data <- ubNCL(X, Y, k, verbose)
  if (type == "ubTomek") 	    data <- ubTomek(X, Y, verbose)
  
  if (is.null(data)) 
    stop("technique", type, " not supported")
  
  X <- data$X
  Y <- data$Y
  id.rm <- data$id.rm
  if (is.null(id.rm)) 
    id.rm <- NA
  
  N <- length(Y)
  
  # Id <- sample(1:N)
  # if (!is.vector(X)) 
  # X = X[Id, ] 
  # else {
  # # is.vector
  # X = X[Id]
  # if (any(is.na(X))) 
  # cat("WARNINGS: vector has NAs \n")
  # if (all(X == X[1])) 
  # cat("WARNINGS: constant vector after", type, "\n")
  # }
  # Y = Y[Id]
  
  if (verbose) {
    cat("Proportion of positives after", type, ":", 
        round(length(which(Y == 1))/N * 100, digits = 2), "% of", N, "observations \n")
  }
  
  #transform the outout with the original labels
  Y <- factor(Y == 1, levels = c(FALSE, TRUE), labels = lev)
  
  return(list(X = X, Y = Y, id.rm = id.rm))
}

ubOver <-
function(X, Y, k = 0, verbose=TRUE) {
  
  
  stopifnot(k >= 0, class(verbose) == "logical", all(unique(Y) %in% c(0, 1)))
  
  i.1 <- which(Y == 1)
  N.1 <- length(i.1)
  i.0 <- which(Y == 0)
  N.0 <- length(i.0)
  max.k <- floor(N.0/N.1)
      
  if (k == 0) {
    # sample with replacement from the minority class to obtain a balanced dataset
    i.1.over <- sample(i.1, N.0, replace = TRUE)
  }
  
  if (k > 0) {
    # sample with replacement from the minority class until we have k-times the orginal number of 1s
    N.1.over <- N.1 * k
    if (N.1.over > N.0) {
      if (verbose)
        cat("Max number of times allowed to replicate minority class is", max.k, 
            "\n taking as many samples as the majority class \n")
      N.1.over <- N.0
    }
    
    i.1.over <- sample(i.1, N.1.over, replace = TRUE)
  }
  
  Id = c(i.0, i.1.over)
  Id <- sort(Id)
  
  if (is.vector(X) != TRUE) 
    X = X[Id, ] else X = X[Id]
  
  Y = Y[Id]
  
  return(list(X = X, Y = Y))
}

ubRacing <-
function(formula, data, algo, positive=1, ncore = 1, nFold=10, maxFold=10, 
                   maxExp=100, stat.test="friedman", metric="f1", ubConf, verbose=FALSE, ...){
  
  stopifnot(class(formula)=="formula", NROW(data)>1, NCOL(data)>1, is.logical(verbose), ncore>0, nFold>1)
  metric <- match.arg(metric, c("f1","gmean", "auc"))
  stat.test <- match.arg(stat.test, c("friedman","t.bonferroni", "t.holm", "t.none", "no"))
  stopifnot(class(ubConf)=="list", names(ubConf) %in% c("type", "percOver", "percUnder", "k", "perc", "method", "w"))
  
  target <- as.character(formula[[2]])
  tgt <- which(names(data) == target)
  if(length(tgt) == 0)
    stop("target variable not defined")
  
  
  predCandidate <- function(Xtr, Ytr, Xts, Yts, algo, balType, positive, ubConf, metric, verbose, ...){
    
    if (balType != "unbal"){
      #re-balance the dataset
      data <- ubBalance(Xtr, factor(Ytr), type=balType, positive=positive, 
                        ubConf$percOver, ubConf$percUnder, ubConf$k, 
                        ubConf$perc, ubConf$method, ubConf$w, verbose)
      TR <- data.frame(data$X, Y=as.factor(data$Y)) 
    } else 
      TR <- data.frame(Xtr, Y=as.factor(Ytr)) 
    
    #single prediction without parameter tuning
    #library(mlr)
    lrnTask <- makeClassifTask(id=paste(algo, balType, sep="_"), data=TR, target="Y", positive=positive)
    lrnTask <- removeConstantFeatures(lrnTask, show.info=verbose)
    L <- lrnTask$task.desc$class.levels
    negative <- setdiff(L, positive)
    if(length(L) > 2)
      stop("only binary classification supported yet")
    
    race.lrn <- paste(lrnTask$task.desc$type, algo, sep=".")
    lrn <- makeLearner(race.lrn, predict.type = "prob", ...)
    mod <- train(lrn, lrnTask)  
    newdata <- data.frame(Xts, Y=as.factor(Yts)) 
    pred <- predict(mod, newdata=newdata)
    
    perf <- mlr::performance(pred, measures = list(gmean, f1, mlr::auc))
    res.metric <- as.numeric(perf[metric])
    #revert metric since racing is a minimizing algorithm
    res <- 1 - res.metric
    
    res
  }
  
  
  #test each methods on the same observations
  #return a vector of errors (1 or 0 for each method)
  testCandidates <- function(Xtr, Xts, Ytr, Yts, algo, positive, balanceTypes, ubConf, metric, ncore, verbose, ...){
    nBalanceTypes <- length(balanceTypes)
    
    #library(doParallel)
    if (ncore > 1) {  
      doParal <- `%dopar%`
    } else {
      doParal <- `%do%`
    }
    
    j <- NULL 
    
    #We assume that a cluster is already registered!
    #library(foreach)
    #make predictions
    error <- doParal( foreach(j=1:nBalanceTypes, .combine=c, .packages=c('mlr'), 
    						.export=c('predCandidate', 'ubBalance', 'ubUnder', 'ubCNN', 'ubENN', 
  									'ubNCL', 'ubOSS', 'ubOver', 'ubSMOTE', 'ubSmoteExs', 'ubTomek')), 
                      predCandidate(Xtr, Ytr, Xts, Yts, algo, balanceTypes[j], positive, ubConf, metric, verbose, ...))
    
    #   error <- NULL
    #   for(j in 1:nBalanceTypes) {  
    #     error <- c(error, predCandidate(Xtr, Ytr, algo, balanceTypes[j], positive, ubConf, metric, verbose, ...))
    #   }
    

    names(error) <- balanceTypes
    return(error)
  }
  
  
  
 
  
  
  #from race package but edited
  aux2.friedman.edit<- function(y, I = 1:ncol(y), n=nrow(y), conf.level = 0.95,interactive=F) {
    k <- length(I)
    r <- t(apply(y[1:n, I, drop=FALSE], 1, rank))
    A <- sum(as.vector(r)^2)
    R <- apply(r, 2, sum)
    J <- I[order(R)]
    alpha <- 1 - conf.level
    TIES <- tapply(r, row(r), table)
    STATISTIC <- ((12 * sum((R - n * (k + 1)/2)^2))/(n * 
                                                       k * (k + 1) - (sum(unlist(lapply(TIES, function(u) {
                                                         u^3 - u
                                                       })))/(k - 1))))
    PARAMETER <- k - 1
    PVAL <- pchisq(STATISTIC, PARAMETER, lower.tail = FALSE)
    if (!is.nan(PVAL) && (PVAL < alpha)) {
      if (interactive) 
        cat("|-|")
      t <- qt(1 - alpha/2, (n - 1) * (k - 1)) * (2 * (n * 
                                                        A - sum(R^2))/((n - 1) * (k - 1)))^(1/2)
      o <- order(R)
      J <- I[o[1]]
      for (j in 2:k) if (abs(R[o[j]] - R[o[1]]) > t) 
        break
      else J <- c(J, I[o[j]])
    }
    else {
      if (interactive) 
        cat("|=|")
    }
    return(J)
  }
  
  #from race package but edited    
  aux.friedman.edit<- function(Results,no.subtasks.sofar,alive,conf.level=0.95,interactive=F) {
    which.alive <- which(alive)
    no.alive<-length(which.alive)
    
    if (no.alive == 2) {
      V1 <- Results[1:(no.subtasks.sofar), which.alive[1]]
      V2 <- Results[1:(no.subtasks.sofar), which.alive[2]]
      PVAL <- wilcox.test(V1, V2, paired = TRUE, exact = FALSE)$p.value
      D <- V1 - V2
      w.stat <- sum(sign(D) * rank(abs(D)))
      if (!is.nan(PVAL) && !is.na(PVAL) && (PVAL < 1 - conf.level)) {
        if (interactive) 
          cat("|-|")
        if (w.stat < 0) {
          best <- which.alive[1]
          alive[which.alive[2]] <- FALSE
        }
        else {
          best <- which.alive[2]
          alive[which.alive[1]] <- FALSE
        }
      }
      else {
        if (interactive) 
          cat("|=|")
        if (w.stat < 0) {
          best <- which.alive[1]
        }
        else {
          best <- which.alive[2]
        }
      }
    }
    else {
      J <- aux2.friedman.edit(Results[1:(no.subtasks.sofar), ,drop=FALSE], I=which.alive, conf.level=conf.level, interactive=interactive)
      alive[-J] <- FALSE
      best <- J[1]
    }
    
    return(list(alive=alive,best=best))
  }
  
  #from race package but edited
  aux.ttest.edit <- function(Results,no.subtasks.sofar,alive,adjust=c("none", "bonferroni", "holm"),conf.level=0.95,interactive=F) {
    which.alive <- which(alive)
    no.alive<-length(which.alive)
    
    adjust <- match.arg(adjust)
    mean.all <- array(0, c(ncol(Results)))
    for (j in 1:ncol(Results)) mean.all[j] <- sum(Results[1:no.subtasks.sofar, 
                                                          j]/no.subtasks.sofar)
    best <- match(min(mean.all[alive]), mean.all)
    PJ <- array(0, dim = c(2, 0))
    for (j in which.alive) {
      Vb <- Results[1:no.subtasks.sofar, best]
      Vj <- Results[1:no.subtasks.sofar, j]
      p <- t.test(Vb, Vj, paired = TRUE)$p.value
      if (!is.nan(p) & !is.na(p)) 
        PJ <- array(c(PJ, j, p), dim = dim(PJ) + c(0, 
                                                   1))
    }
    PJ[2, ] <- p.adjust(PJ[2, ], method = adjust)
    dropped.any <- FALSE
    for (j in 1:ncol(PJ)) if (PJ[2, j] < (1 - conf.level)) {
      alive[PJ[1, j]]<- FALSE
      dropped.any <- TRUE
    }
    if (interactive) {
      if (dropped.any) 
        cat("|-|")
      else cat("|=|")
    }
    return(list(alive=alive,best=best))
  }
  
  #from race package but edited
  format.precis <- function(title, value,title.width,value.width) {
    dots <- function(n) return(paste(rep(".", n), collapse = ""))
    spaces <- function(n) return(paste(rep(" ", n), collapse = ""))
    string <- paste(title, dots(title.width - nchar(title)), sep = "")
    if (nchar(value) <= value.width) {
      string <- paste(string, dots(value.width - nchar(value)),value, sep = "")
    }
    else {
      f.vec <- strwrap(value, width = value.width)
      first <- f.vec[1]
      first <- paste(dots(title.width - nchar(first)), 
                     first, sep = "")
      rest <- format(f.vec[-1])
      rest <- paste(spaces(title.width + value.width - max(nchar(rest))), rest, sep = "", collapse = "\n")
      string <- paste(string, paste(first, rest, sep = "\n"), sep = "")
    }
    return(paste(string, "\n"))
  }
  
  
  #from function createFolds in caret package but edited
  idFolds <- function(y, k = 10){
    
    stopifnot(k > 0)
    
    if (is.numeric(y)) {
      cuts <- floor(length(y)/k)
      if (cuts < 2) 
        cuts <- 2
      if (cuts > 5) 
        cuts <- 5
      y <- cut(y, unique(quantile(y, probs = seq(0, 1, length = cuts))), include.lowest = TRUE)
    }
    if (k < length(y)) {
      y <- factor(as.character(y))
      numInClass <- table(y)
      foldVector <- vector(mode = "integer", length(y))
      for (i in 1:length(numInClass)) {
        seqVector <- rep(1:k, numInClass[i]%/%k)
        if (numInClass[i]%%k > 0) 
          seqVector <- c(seqVector, sample(1:k, numInClass[i]%%k))
        foldVector[which(y == dimnames(numInClass)$y[i])] <- sample(seqVector)
      }
    } else 
      foldVector <- seq(along = y)
    
    
    foldVector
  }
  
  foldVector <- idFolds(data[ ,tgt], nFold)
  input <- data[ ,-tgt]
  output <-  data[ ,tgt]
  
  balanceTypes <- c("unbal", "ubOver", "ubUnder", "ubSMOTE", "ubOSS","ubCNN", "ubENN", "ubNCL", "ubTomek")
  nBalanceTypes <- length(balanceTypes)
  title <- paste("Racing for unbalanced methods selection in", nFold, "fold CV")
  title.width<-32
  value.width<-title.width
  precis <- paste("\n", title,"\n",
                  format.precis("Number of candidates", nBalanceTypes, title.width, value.width), 
                  format.precis("Max number of folds in the CV", maxFold,title.width,value.width), 
                  format.precis("Max number of experiments", ifelse(maxExp, maxExp, "unlimited"),title.width,value.width), 
                  #format.precis("Metric", metric, title.width, value.width), 
                  format.precis("Statistical test", 
                                switch(stat.test, 
                                       friedman = "Friedman test", 
                                       t.bonferroni = "t-test with Bonferroni's correction for multiple comparisons", 
                                       t.holm = "t-test with Holm's correction for multiple comparisons", 
                                       t.none = "t-test with no correction for multiple comparisons",
                                       no = "No test"),title.width,value.width)
  )
  cat(precis) 
  if (nBalanceTypes > maxExp & maxExp!=0) 
    stop("Max number of experiments is smaller than number of candidates")
  if (maxFold > nFold)
    maxFold <- nFold 
  
  Results <- matrix(NA, nrow=nFold, ncol=nBalanceTypes)
  colnames(Results) <- balanceTypes
  alive <- rep(TRUE,nBalanceTypes)
  n.Exp <- 0
  n.alive <- nBalanceTypes
  types.alive <- balanceTypes
  
  #open a cluster
  if (ncore > 1) {  
    cl <- makeCluster(ncore)
    cat(" Parallel execution with", ncore, "cores \n")
    registerDoParallel(cl)  
  } else
	makeCluster <- NULL
  
  cat("                                                               \n",
      "                            Markers:                           \n",
      "                               x No test is performed.         \n",
      "                               - The test is performed and     \n",
      "                                 some candidates are discarded.\n", 
      "                               = The test is performed but     \n",
      "                                 no candidate is discarded.    \n",
      "                                                               \n",
      "+-+-----------+-----------+-----------+-----------+-----------+\n", 
      "| |       Fold|      Alive|       Best|  Mean best| Exp so far|\n", 
      "+-+-----------+-----------+-----------+-----------+-----------+\n")
  
  for(i in 1:nFold){
    n.Exp <- n.Exp + n.alive
    
    if ((n.Exp>maxExp | maxFold<i) & maxExp!=0 | n.alive==1) 
      break()
    
    max.tasks <- i
    id.fold <- which(foldVector == i)
    
    Xtr <- input[foldVector == i, ]
    Xts <- input[foldVector != i, ]
    Ytr <- output[foldVector == i]
    Yts <- output[foldVector != i]
    
    if(any(is.na(types.alive)))
      stop("NAs in balanceTypes")
    
    err <- testCandidates(Xtr, Xts, Ytr, Yts, algo, positive, types.alive, ubConf, metric, ncore, verbose, ...)
    Results[i, match(types.alive, balanceTypes)] <- err
    
    #the best candidate is the one that obtains the smallest results on the various tasks considered
    if (i==1)
      best <- as.numeric(which(err==min(err)))[1]
    #make a test on the error
    if (i>1){	
      if (stat.test=="friedman")
        test <- aux.friedman.edit(Results, no.subtasks.sofar=i, alive, conf.level=0.95, interactive=TRUE) 
      if (stat.test=="t.none")
        test<-aux.ttest.edit(Results,no.subtasks.sofar=i,alive,"none", conf.level=0.95)
      if (stat.test=="t.holm")
        test<-aux.ttest.edit(Results,no.subtasks.sofar=i,alive,"holm", conf.level=0.95)
      if (stat.test=="t.bonferroni")
        test<-aux.ttest.edit(Results,no.subtasks.sofar=i,alive,"bonferroni", conf.level=0.95)
      if (stat.test=="no"){
        test <- list(alive=rep(TRUE, nBalanceTypes), best=as.numeric(which(err==min(err)))[1])
        cat("|x|")
      }
      
      alive <- test$alive
      best <- test$best
    }
    #remove significantly worse mehtods
    which.alive <- which(alive)
    n.alive <- length(which.alive)
    types.alive <- balanceTypes[which.alive]	
    if(i==1){
      avg.best <- min(err)
      cat(" |x|")
    }
    else 
      avg.best <- as.numeric(apply(Results, 2, mean, na.rm=TRUE)[best])
    
    #revert metric since racing is a minimizing algorithm
    avg.best <- 1 - avg.best
    
    cat(paste(formatC(i, width = 11), "|", 
              formatC(n.alive, width = 11), "|", 
              formatC(best, width = 11), "|", 
              formatC(avg.best, width = 11), "|",
              formatC(n.Exp, width = 11), "|\n"," ",
              sep = ""))
    
  }
  
  cat("+-+-----------+-----------+-----------+-----------+-----------+\n")
  colnames(Results) <- balanceTypes
  Results <- Results[1:max.tasks, ]
  #revert metric since racing is a minimizing algorithm
  Results <- 1 - Results
  #write.csv(Results,file="Race.csv")
  
  #close the cluster
  if (ncore > 1) {
    stopCluster(cl)
    rm(cl)
  } else
	stopCluster <- NULL
  
  if(max.tasks>1){
    avg.err <- apply(Results, 2, mean, na.rm=TRUE)
    sd.err <- apply(Results, 2, sd, na.rm=TRUE)
  }
  else {	#max.tasks==1
    avg.err <- Results
    sd.err <- Results
  }
  avg.best <- as.numeric(avg.err[best])
  sd.best <- as.numeric(sd.err[best])
  best.desc <- balanceTypes[best]
  #percentage of computational gain
  percGain <- round((1 - n.Exp/(nFold*nBalanceTypes))*100, 0)
  
  cat("Selected candidate:",best.desc,"\t metric:", metric, "\t mean value:", round(avg.best, 4),"\n")
  return(list(best=best.desc, avg=avg.best, sd=sd.best, N.test=n.Exp, Gain=percGain, Race=Results))
  
}

ubCNN <-
function(X,Y,k=1,verbose=T){
  
  #only numeric features are allowed
  is.not.num<-which(sapply(X,is.numeric)==FALSE)
  if(length(is.not.num)>0)
    stop("only numeric features are allowed to compute nearest neighbors")
  
  S.X<-X
  S.Y<-Y
  i.1<-which(Y==1)
  i.0<-which(Y==0)
  N.1<-length(i.1)
  N.0<-length(i.0)
  if(N.1==0 | N.0==0) {
    if(verbose) cat("All instances of the same class \n")
    return(list(X=X,Y=Y))
  }
  
  #initially C contains all 1s from S and one random 0 obs
  id.C<-c(i.1,sample(i.0,1))	
  C.X<-X[id.C,]
  C.Y<-Y[id.C]
  #use C to to build a 1-NN and classify all obs in S
  Y.knn<-knn(C.X,S.X,C.Y,k)
  #move missclassified obs into C
  id.miss<-which(S.Y!=Y.knn)
  id.C<-c(id.C,id.miss)
  # id.C<-sample(id.C)
  X<-X[id.C, ]
  Y<-Y[id.C]
  #now C is consistent with S
  
  return(list(X=X,Y=Y))
}

ubTomek <-
function(X, Y, verbose=TRUE){
  
  stopifnot(class(verbose) == "logical", all(unique(Y) %in% c(0, 1)))
  
  #only numeric features are allowed
  if(any(sapply(X,is.numeric)==FALSE))
    stop("only numeric features are allowed to compute nearest neighbors")
  
  N<-nrow(X)
  i.1<-which(Y==1)
  i.0<-which(Y==0)
  N.1<-length(i.1)
  N.0<-length(i.0)
  if(N.1==0 | N.0==0) {
    if(verbose) 
      print("observations of the same class, no majority class removed using Tomek links")
    return(list(X=X,Y=Y))
  }
  else {
    X.1<-X[i.1,]
    Y.1<-Y[i.1]
    timeTomek<-system.time({
      #retrive the nearest neighbor (nn) of minority examples
      #nn<-get.knnx(data=cbind(X,Y),query=cbind(X.1,Y.1),k=2)$nn.index
      nn<-nn2(data=X,query=X.1, k=2)$nn.idx
      nn.1<-nn[,2] #the 1-nn is the second column, the first is the point itself
      #if the nn is from the majority class than it is a tomek link
      indexTomekLinks<-(Y[nn.1]==0)
      id2remove<-unique(nn.1[which(indexTomekLinks==T)])
    })	 
    
    if(any(Y[id2remove]==1))  stop("Error: class 1 removed")
    
    id2keep<-setdiff(1:N, id2remove) 
    Xred<-X[id2keep,]
    Yred<-Y[id2keep]
    
    if(verbose){	
      cat("Instances removed",N-length(id2keep),":",
          round((N-length(id2keep))/N.0*100,digits=2),"% of 0 class ;",
          round((N-length(id2keep))/N*100,digits=2),"% of training ; Time needed",
          round(as.numeric(timeTomek["elapsed"]),digits=2),"\n")
    }
    return(list(X=Xred,Y=Yred,id.rm=id2remove))
  }
}

ubUnder <-
function(X, Y, perc = 50, method = "percPos", w = NULL) {
  
  stopifnot(all(unique(Y) %in% c(0, 1)))
  
  N <- length(Y)
  i.1 <- which(Y == 1)
  N.1 <- length(i.1)
  i.0 <- which(Y == 0)
  N.0 <- length(i.0)
  if (N.1 >= N.0)
    stop("less 0s instances than 1s, the minority class has to be class 1")
  
  type = match.arg(method, c("percPos", "percUnder"))
  
  if (type == "percPos") {
    #perc < (N.1/N * 100)) means removing minority observations
    stopifnot(perc >= (N.1/N * 100), perc <= 50)
    N.0.sub <- floor(N.1 * (100 - perc) / perc)
  } 
  
  if (type == "percUnder") {
    # perc = N.1/N.0 * 100 is the minimum value allowed that correspond to percPos with perc = 50
    stopifnot(perc >= N.1/N.0 * 100, perc <= 100)
    N.0.sub <- floor(perc/100 * N.0)
  }
  
  # if the weights are not given, assign equal probability to all examples.
  if (is.null(w)) 
    w <- rep(1/N.0, N.0)
  
  if (N.0.sub <= N.0) 
    i.0.sub <- sample(i.0, N.0.sub, prob = w) else
      stop("subset of majoirty instances bigger than orginal set of majoirty instances")
  
  i.0.rm <- setdiff(i.0, i.0.sub)  
  Id <- c(i.0.sub, i.1)
  Id <- sort(Id)
  
  if (is.vector(X) != TRUE) 
    X <- X[Id, ] else X <- X[Id]
  Y <- Y[Id]
  
  return(list(X = X, Y = Y, id.rm = i.0.rm))
}

ubSmoteExs <-
function(data,tgt,N=200,k=5) {
  # INPUTS:
  # data are the rare cases (the minority "class" cases)
  # tgt is the name of the target variable
  # N is the percentage of over-sampling to carry out;
  # and k is the number of nearest neighours to use for the generation
  # OUTPUTS:
  # The result of the function is a (N/100)*T set of generated
  # examples with rare values on the target

  nomatr <- c()
  T <- matrix(nrow=dim(data)[1],ncol=dim(data)[2]-1)
  for(col in seq.int(dim(T)[2])){
    cl <- class(data[,col])

    if (cl %in% c('Date','POSIXct','POSIXt')) 
      stop("cannot SMOTE variables of class Date, POSIXct or POSIXt")
  
    if (cl %in% c('factor','character')) {
      T[,col] <- as.integer(data[,col])
      nomatr <- c(nomatr,col)
    } else 
      T[,col] <- data[,col]
  }
    
  
  if (N < 100) { # only a percentage of the T cases will be SMOTEd
    nT <- NROW(T)
    idx <- sample(1:nT,as.integer((N/100)*nT))
    T <- T[idx,]
    N <- 100
  }
  
  p <- dim(T)[2]
  nT <- dim(T)[1]
  
  ranges <- apply(T,2,max)-apply(T,2,min)
  
  nexs <-  as.integer(N/100) # this is the number of artificial exs generated
  # for each member of T
  new <- matrix(nrow=nexs*nT,ncol=p)    # the new cases
  
  for(i in 1:nT) {
    
    # the k NNs of case T[i,]
    xd <- scale(T,T[i,],ranges)
    for(a in nomatr) 
      xd[,a] <- xd[,a]==0
    dd <- drop(xd^2 %*% rep(1, ncol(xd)))
    kNNs <- order(dd)[2:(k+1)]
    
    for(n in 1:nexs) {
      # select randomly one of the k NNs
      neig <- sample(1:k,1)
      
      ex <- vector(length=ncol(T))
      
      # the attribute values of the generated case
      difs <- T[kNNs[neig],]-T[i,]
      new[(i-1)*nexs+n,] <- T[i,]+runif(1)*difs
      for(a in nomatr)
        new[(i-1)*nexs+n,a] <- c(T[kNNs[neig],a],T[i,a])[1+round(runif(1),0)]
      
    }
  }
  newCases <- data.frame(new)
  for(a in nomatr)
    newCases[,a] <- factor(newCases[,a],levels=1:nlevels(data[,a]),labels=levels(data[,a]))
  
  newCases[,tgt] <- factor(rep(data[1,tgt],nrow(newCases)),levels=levels(data[,tgt]))
  colnames(newCases) <- colnames(data)
  newCases
}

ubNCL <-
function(X, Y, k = 3, verbose = TRUE) {
  
  stopifnot(k > 0, class(verbose) == "logical", all(unique(Y) %in% c(0, 1)))
  
  #only numeric features are allowed
  if(any(sapply(X,is.numeric)==FALSE))
    stop("only numeric features are allowed to compute nearest neighbors")
  
  N.orig <- length(Y)
  # If an instance belongs to the majority class and the classification given by its
  # three nearest neighbors contradicts the original class, then it is removed
  data <- ubENN(X, Y, k, verbose)
  X <- data$X
  Y <- data$Y
  
  N <- length(Y)
  i.1 <- which(Y == 1)
  i.0 <- which(Y == 0)
  
  if (length(i.0) == 0) {
    # if there are no 0 obs then don't do anything
    if (verbose) 
      cat("Warning: No remaining majority instances after ENN \n")
    return(list(X = X, Y = Y))
  }
  
  # If an instance belongs to the minority class and its nearest neighbors
  # misclasify it, then the nearest neighbors that belong to the majority class are removed.
  timeRemove <- system.time({
    out.hat <- FNN::knn(train = X, test = X[i.1, ], cl = Y, k = k + 1, prob = TRUE)
    proba.hat <- attr(out.hat, "prob")
    levels(out.hat) <- c(0, 1)
    prob.th <- k/(k+1)
    id.miss <- which((Y[i.1] != out.hat) & (proba.hat >= prob.th))
    if (length(id.miss) == 0) {
      Id <- 1:N
      id2remove <- NULL
    } else {
      out.nn <- attr(out.hat, "nn.index")[, -1]  #the fist column is the point itself
      if (!is.vector(out.nn)) 
        nn.miss <- out.nn[id.miss, ] else nn.miss <- out.nn[id.miss]
      nn.2check <- unique(as.vector(nn.miss))
      id2remove <- nn.2check[which(Y[nn.2check] == 0)]
      Id <- setdiff(1:N, id2remove)
    }
  })
  if (verbose) 
    cat("Number of instances removed from majority class after ENN:", length(id2remove), 
        "\t Time needed:", round(timeRemove[3], digits = 2), "\n")
  
  Id <- sort(Id)
  if (is.vector(X) != TRUE) 
    X = X[Id, ] else X = X[Id]
  Y = Y[Id]
  N.left <- length(Y)
  if (verbose) 
    cat("Number of instances removed from majority class:", N.orig - N.left, "\n")
  
  return(list(X = X, Y = Y))
}

\name{ubTomek}
\alias{ubTomek}

\title{Tomek Link}

\description{The function finds the points in the dataset that are tomek link using 1-NN and then removes only majority class instances that are tomek links.}

\usage{ubTomek(X, Y, verbose = TRUE)}


\arguments{
\item{X}{the input variables of the unbalanced dataset.}
  \item{Y}{the response variable of the unbalanced dataset. 
          It must be a binary factor where the majority class is coded as 0 and the minority as 1.}
  \item{verbose}{print extra information (TRUE/FALSE)}
}


\details{In order to compute nearest neighbors, only numeric features are allowed.}

\value{
  The function returns a list:
  \item{X}{input variables}
  \item{Y}{response variable}
  \item{id.rm}{index of instances removed}
}

\references{I. Tomek. Two modifications of cnn. IEEE Trans. Syst. Man Cybern., 6:769-772, 1976.}

\seealso{
\code{\link{ubBalance}}
}

\examples{
library(unbalanced)
data(ubIonosphere)
n<-ncol(ubIonosphere)
output<-ubIonosphere$Class
input<-ubIonosphere[ ,-n]

data<-ubTomek(X=input, Y= output)
newData<-cbind(data$X, data$Y)
}

\name{ubENN}
\alias{ubENN}

\title{Edited Nearest Neighbor}

\description{Edited Nearest Neighbor removes any example whose class label differs from the class of at least two of its three nearest neighbors.}

\usage{ubENN(X, Y, k = 3, verbose = TRUE)}

\arguments{
  \item{X}{the input variables of the unbalanced dataset.}
  \item{Y}{the response variable of the unbalanced dataset. 
          It must be a binary factor where the majority class is coded as 0 and the minority as 1.}
  \item{k}{the number of neighbours to use}
  \item{verbose}{print extra information (TRUE/FALSE)}
}


\details{In order to compute nearest neighbors, only numeric features are allowed.}

\value{
  The function returns a list:
  \item{X}{input variables}
  \item{Y}{response variable}
}

\references{D. Wilson. Asymptotic properties of nearest neighbor rules using edited data. Systems, Man and Cybernetics, IEEE Transactions on, 408-421, 1972.}


\seealso{
\code{\link{ubBalance}}
}

\examples{
library(unbalanced)
data(ubIonosphere)
n<-ncol(ubIonosphere)
output<-ubIonosphere$Class
input<-ubIonosphere[ ,-n]

data<-ubENN(X=input, Y= output)
newData<-cbind(data$X, data$Y)
}

\name{ubBalance}
\alias{ubBalance}

\title{Balance wrapper}

\description{The function implements several techniques to re-balance or remove noisy instances in unbalanced datasets.}

\usage{ubBalance(X, Y, type="ubSMOTE", positive=1, percOver=200, percUnder=200, 
          k=5, perc=50, method="percPos", w=NULL, verbose=FALSE)}

\arguments{
  \item{X}{the input variables of the unbalanced dataset.}
  \item{Y}{the response variable of the unbalanced dataset.}
  \item{type}{the balancing technique to use (ubOver, ubUnder, ubSMOTE, ubOSS, ubCNN, ubENN, ubNCL, ubTomek).}
  \item{positive}{the majority class of the response variable.}
  \item{percOver}{parameter used in ubSMOTE}
  \item{percUnder}{parameter used in ubSMOTE}
  \item{k}{parameter used in ubOver, ubSMOTE, ubCNN, ubENN, ubNCL}
  \item{perc}{parameter used in ubUnder}
  \item{method}{parameter used in ubUnder}
  \item{w}{parameter used in ubUnder}
  \item{verbose}{print extra information (TRUE/FALSE)}
}


\details{The argument type can take the following values: "ubOver" (over-sampling), "ubUnder" (under-sampling), "ubSMOTE" (SMOTE), "ubOSS" (One Side Selection), "ubCNN" (Condensed Nearest Neighbor), "ubENN" (Edited Nearest Neighbor), "ubNCL" (Neighborhood Cleaning Rule), "ubTomek" (Tomek Link).}

\value{
  The function returns a list:
  \item{X}{input variables}
  \item{Y}{response variable}
  \item{id.rm}{index of instances removed if availble in the technique selected}
}
\references{Dal Pozzolo, Andrea, et al. "Racing for unbalanced methods selection." Intelligent Data Engineering and Automated Learning - IDEAL 2013. Springer Berlin Heidelberg, 2013. 24-31.}


\seealso{
\code{\link{ubRacing}}, \code{\link{ubOver}}, \code{\link{ubUnder}}, \code{\link{ubSMOTE}}, \code{\link{ubOSS}}, \code{\link{ubCNN}}, \code{\link{ubENN}}, \code{\link{ubNCL}}, \code{\link{ubTomek}}
}

\examples{
library(unbalanced)
data(ubIonosphere)
n<-ncol(ubIonosphere)
output<-ubIonosphere$Class
input<-ubIonosphere[ ,-n]

#balance the dataset
data<-ubBalance(X= input, Y=output, type="ubSMOTE", percOver=300, percUnder=150, verbose=TRUE)
balancedData<-cbind(data$X,data$Y)
}

\name{ubNCL}
\alias{ubNCL}

\title{Neighborhood Cleaning Rule}
\description{
Neighborhood Cleaning Rule modifies the Edited Nearest Neighbor method by increasing the role of data cleaning.
Firstly, NCL removes negatives examples which are misclassified by their 3-nearest neighbors. 
Secondly, the neighbors of each positive examples are found and the ones belonging to the majority class are removed.
}

\usage{ubNCL(X, Y, k = 3, verbose = TRUE)}

\arguments{
 \item{X}{the input variables of the unbalanced dataset.}
  \item{Y}{the response variable of the unbalanced dataset. 
          It must be a binary factor where the majority class is coded as 0 and the minority as 1.}
  \item{k}{the number of neighbours to use}
  \item{verbose}{print extra information (TRUE/FALSE)}
}

\details{In order to compute nearest neighbors, only numeric features are allowed.}

\value{
  The function returns a list:
  \item{X}{input variables}
  \item{Y}{response variable}
}

\references{J. Laurikkala. Improving identification of difficult small classes by balancing class distribution. Artificial Intelligence in Medicine, pages 63-66, 2001.}


\seealso{
\code{\link{ubBalance}}
}

\examples{
library(unbalanced)
data(ubIonosphere)
n<-ncol(ubIonosphere)
output<-ubIonosphere$Class
input<-ubIonosphere[ ,-n]

data<-ubNCL(X=input, Y= output)
newData<-cbind(data$X, data$Y)
}

\name{ubUnder}
\alias{ubUnder}

\title{Under-sampling}

\description{The function removes randomly some instances from the majority (negative) class and keeps all instances in the minority (positive) class in order to obtain a more balanced dataset.
It allows two ways to perform undersampling: 
i) by setting the percentage of positives wanted after undersampling (percPos method),
ii) by setting the sampling rate on the negatives, (percUnder method).
For percPos, "perc"has to be (N.1/N * 100) <=  perc <= 50, where N.1 is the number of positive and N the total number of instances. 
For percUnder, "perc"has to be (N.1/N.0 * 100) <=  perc <= 100, where N.1 is the number of positive and N.0 the number of negative instances. 
}

\usage{ubUnder(X, Y, perc = 50, method = "percPos", w = NULL)}


\arguments{
  \item{X}{the input variables of the unbalanced dataset.}
  \item{Y}{the response variable of the unbalanced dataset. 
          It must be a binary factor where the majority class is coded as 0 and the minority as 1.}
  \item{perc}{percentage of sampling.}
  \item{method}{method to perform under sampling ("percPos", "percUnder").}
  \item{w}{weights used for sampling the majority class, if NULL all majority instances are sampled with equal weights}
}


\value{
The function returns a list:
  \item{X}{input variables}
  \item{Y}{response variable}
  \item{id.rm}{index of instances removed}
}


\seealso{
\code{\link{ubBalance}}
}

\examples{
library(unbalanced)
data(ubIonosphere)
n<-ncol(ubIonosphere)
output<-ubIonosphere$Class
input<-ubIonosphere[ ,-n]

data<-ubUnder(X=input, Y= output, perc = 40,  method = "percPos")
newData<-cbind(data$X, data$Y)
}

\name{ubOSS}
\alias{ubOSS}

\title{One Side Selection}

\description{One Side Selection is an undersampling method resulting from the application of Tomek links followed by the application of Condensed Nearest Neighbor.}

\usage{ubOSS(X, Y, verbose = TRUE)}

\arguments{
  \item{X}{the input variables of the unbalanced dataset.}
  \item{Y}{the response variable of the unbalanced dataset. 
          It must be a binary factor where the majority class is coded as 0 and the minority as 1.}
  \item{verbose}{print extra information (TRUE/FALSE)}
}

\details{In order to compute nearest neighbors, only numeric features are allowed.}

\value{
  The function returns a list:
  \item{X}{input variables}
  \item{Y}{response variable}
}

\references{M. Kubat, S. Matwin, et al. Addressing the curse of imbalanced training sets: one-sided selection. In MACHINE LEARNING-INTERNATIONAL WORKSHOP THEN CONFERENCE-, pages 179-186. MORGAN KAUFMANN PUBLISHERS, INC., 1997.}


\seealso{
\code{\link{ubBalance}}
}

\examples{
library(unbalanced)
data(ubIonosphere)
n<-ncol(ubIonosphere)
output<-ubIonosphere$Class
input<-ubIonosphere[ ,-n]

data<-ubOSS(X=input, Y= output)
newData<-cbind(data$X, data$Y)
}

\name{ubIonosphere}
\alias{ubIonosphere}
\docType{data}

\title{Ionosphere dataset}

\description{
The datasets is a modifcation of Ionosphere dataset cotained in "mlbench" package.
It contains only numerical input variables, i.e. the first two variables are removed.
The Class variable orginally taking values bad and good has been transformed into a factor where 1 denotes bad and 0 good.
}

\usage{data(ubIonosphere)}
\format{
  A data frame with 351 observations on 33 independent variables (all numerical) and one last defining the class (1 or 0).
}

\source{\url{http://cran.r-project.org/package=mlbench}}

\examples{
data(ubIonosphere)
summary(ubIonosphere)
}
\keyword{datasets}

\name{ubOver}
\alias{ubOver}

\title{Over-sampling}

\description{
The function replicates randomly some instances from the minority class in order to obtain a final dataset with the same number of instances from the two classes.}

\usage{ubOver(X, Y, k = 0, verbose=TRUE)}

\arguments{
  \item{X}{the input variables of the unbalanced dataset.}
  \item{Y}{the response variable of the unbalanced dataset. 
          It must be a binary factor where the majority class is coded as 0 and the minority as 1.}
  \item{k}{defines the sampling method.}
  \item{verbose}{print extra information (TRUE/FALSE)}
}


\details{
If K=0: sample with replacement from the minority class until we have the same number of instances in each class.
If K>0: sample with replacement from the minority class until we have k-times the orginal number of minority instances.
}

\value{
  The function returns a list:
  \item{X}{input variables}
  \item{Y}{response variable}
}

\seealso{
\code{\link{ubBalance}}
}

\examples{
library(unbalanced)
data(ubIonosphere)
n<-ncol(ubIonosphere)
output<-ubIonosphere$Class
input<-ubIonosphere[ ,-n]

data<-ubOver(X=input, Y= output)
newData<-cbind(data$X, data$Y)
}

\name{ubSMOTE}
\alias{ubSMOTE}

\title{SMOTE}

\description{Function that implements SMOTE (synthetic minority over-sampling technique)}

\usage{ubSMOTE(X, Y, perc.over = 200, k = 5, perc.under = 200, verbose = TRUE)}

%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{X}{the input variables of the unbalanced dataset.}
  \item{Y}{the response variable of the unbalanced dataset. 
          It must be a binary factor where the majority class is coded as 0 and the minority as 1.}
  \item{perc.over}{per.over/100 is the number of new instances generated for each rare instance. 
      If perc.over < 100 a single instance is generated.}
  \item{k}{the number of neighbours to consider as the pool from where the new examples are generated}
  \item{perc.under}{perc.under/100 is the number of "normal" (majority class) instances that are randomly selected for each smoted observation.}
  \item{verbose}{print extra information (TRUE/FALSE)}
}

\details{Y must be a factor.}

\value{
  The function returns a list:
  \item{X}{input variables}
  \item{Y}{response variable}
}

\references{Chawla, Nitesh V., et al. "SMOTE: synthetic minority over-sampling technique." arXiv preprint arXiv:1106.1813 (2011).}

\note{Original code from DMwR package}

\seealso{
\code{\link{ubBalance}}
}

\examples{
library(unbalanced)
data(ubIonosphere)
n<-ncol(ubIonosphere)
output<-ubIonosphere$Class
input<-ubIonosphere[ ,-n]

data<-ubSMOTE(X=input, Y= output)
newData<-cbind(data$X, data$Y)
}

\name{ubSmoteExs}
\alias{ubSmoteExs}

\title{ubSmoteExs}

\description{Function used in SMOTE to generate new minority examples.}

\usage{ubSmoteExs(data, tgt, N = 200, k = 5)}

\arguments{
\item{data}{the data.frame}
  \item{tgt}{the index of the target/response variables}
  \item{N}{N/100 is the number of new instances generated for each rare instance. 
      If N < 100 a single instance is generated}
  \item{k}{the number of neighbours to consider as the pool from where the new examples are generated}
}

\details{This function does not handle vectors}

\value{
  newCases
}

\seealso{
\code{\link{ubSMOTE}}
}

\name{ubRacing}
\alias{ubRacing}

\title{Racing}

\description{The function implementes the Racing algorithm [2] for selecting the best technique to re-balance or remove noisy instances in unbalanced datasets [1].}

\usage{
ubRacing(formula, data, algo, positive=1, ncore=1, nFold=10, maxFold=10, maxExp=100, 
          stat.test="friedman", metric="f1", ubConf, verbose=FALSE, ...)
}

\arguments{
  \item{formula}{formula describing the model to be fitted.}
  \item{data}{the unbalanced dataset}
  \item{algo}{the classification algorithm to use with the mlr package.}
  \item{positive}{label of the positive (minority) class.}
  \item{ncore}{the number of core to use in the Race. Race is performed with parallel exectuion when ncore > 1.}
  \item{nFold}{number of folds in the cross-validation that provides the subset of data to the Race}
  \item{maxFold}{maximum number of folds to use in the Race}
  \item{maxExp}{maximum number of experiments to use in the Race}
  \item{stat.test}{statistical test to use to remove candidates which perform significantly worse than the best.}
  \item{metric}{metric used to asses the classification.}
  \item{ubConf}{configuration of the balancing techniques used in the Race.}
  \item{verbose}{print extra information (TRUE/FALSE)}
  \item{\dots}{additional arguments pass to train function in mlr package.}
}

\details{The argument metric can take the following values: "gmean", "f1" (F-score or F-measure), "auc" (Area Under ROC curve).  Argument stat.test defines the statistical test used to remove candidates during the race. It can take the following values: "friedman" (Friedman test), "t.bonferroni" (t-test with bonferroni correction), "t.holm" (t-test with holm correction), "t.none" (t-test without correction), "no" (no test, the Race continues until new subsets of data are provided by the cross validation). Argument balanceConf is a list passed to function ubBalance that is used for configuration.}

\value{
 The function returns a list: 
  \item{Race}{matrix containing accuracy results for each technique in the Race.}              
  \item{best}{best technique selected in the Race.}
  \item{avg}{average of the metric used in the Race for the technique selected.}
  \item{sd}{standard deviation of the metric used in the Race for the technique selected.}
  \item{N.test}{number of experiments used in the Race.}
  \item{Gain}{\% of computational gain with resepct to the maximum number of experiments given by the cross validation.}
}
\references{1. Dal Pozzolo, Andrea, et al. "Racing for unbalanced methods selection." Intelligent Data Engineering and Automated Learning - IDEAL 2013. Springer Berlin Heidelberg, 2013. 24-31.\cr 
2. Birattari, Mauro, et al. "A Racing Algorithm for Configuring Metaheuristics."GECCO. Vol. 2. 2002.}

\note{The function ubRacing is a modified version of the race function availble in the race package: \url{http://cran.r-project.org/package=race}.}

\seealso{
\code{\link{ubBalance}}, \code{\link{ubOver}}, \code{\link{ubUnder}}, \code{\link{ubSMOTE}}, \code{\link{ubOSS}}, \code{\link{ubCNN}}, \code{\link{ubENN}}, \code{\link{ubNCL}}, \code{\link{ubTomek}}
}

\examples{
#use Racing to select the best technique for an unbalanced dataset
library(unbalanced)
data(ubIonosphere)

#configure sampling parameters
ubConf <- list(type="ubUnder", percOver=200, percUnder=200, k=2, perc=50, method="percPos", w=NULL)

#load the classification algorithm that you intend to use inside the Race
#see 'mlr' package for supported algorithms
library(randomForest)
#use only 5 trees
results <- ubRacing(Class ~., ubIonosphere, "randomForest", positive=1, ubConf=ubConf, ntree=5)

# try with 500 trees
# results <- ubRacing(Class ~., ubIonosphere, "randomForest", positive=1, ubConf=ubConf, ntree=500)
# let's try with a different algorithm
# library(e1071)
# results <- ubRacing(Class ~., ubIonosphere, "svm", positive=1, ubConf=ubConf)
# library(rpart)
# results <- ubRacing(Class ~., ubIonosphere, "rpart", positive=1, ubConf=ubConf)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{unbalanced-package}
\alias{unbalanced-package}
\alias{unbalanced}
\docType{package}

\title{Racing for Unbalanced Methods Selection}

\description{A dataset is said to be unbalanced when the class of interest (minority class) is much rarer than normal behaviour (majority class). The cost of missing a minority class is typically much higher that missing a majority class. Most learning systems are not prepared to cope with unbalanced data and several techniques have been proposed to rebalance the classes. This package implements some of most well-known techniques and propose a racing algorithm [2] to select adaptively the most appropriate strategy for a given unbalanced task [1].
}

\details{
\tabular{ll}{
Package: \tab unbalanced\cr
Type: \tab Package\cr
Version: \tab 2.0\cr
Date: \tab 2015-06-17\cr
License: \tab GPL (>= 3)\cr
}

}

\author{
Andrea Dal Pozzolo \email{adalpozz@ulb.ac.be}, Olivier Caelen \email{olivier.caelen@worldline.com} and Gianluca Bontempi \email{gbonte@ulb.ac.be}

Maintainer: Andrea Dal Pozzolo

Andrea Dal Pozzolo and Gianluca Bontempi are with the \href{http://mlg.ulb.ac.be}{Machine Learning Group}, Computer Science Department, Faculty of Sciences ULB, Universite Libre de Bruxelles, Brussels, Belgium.\cr
Olivier Caelen is with the Fraud Risk Management Analytics, Worldline, Belgium.\cr
The work of Andrea Dal Pozzolo is supported by the Doctiris scholarship of Innoviris, Belgium.
}

\references{
1. Dal Pozzolo, Andrea, et al. "Racing for unbalanced methods selection." Intelligent Data Engineering and Automated Learning - IDEAL 2013. Springer Berlin Heidelberg, 2013. 24-31.\cr 
2. Birattari, Mauro, et al. "A Racing Algorithm for Configuring Metaheuristics."GECCO. Vol. 2. 2002.
}

\keyword{unbalanced datasets, imbalanced learning}


\seealso{
\code{\link{ubBalance}}, \code{\link{ubRacing}}
}


\examples{
#use Racing to select the best technique for an unbalanced dataset
library(unbalanced)
data(ubIonosphere)

#configure sampling parameters
ubConf <- list(type="ubUnder", percOver=200, percUnder=200, k=2, perc=50, method="percPos", w=NULL)

#load the classification algorithm that you intend to use inside the Race
#see 'mlr' package for supported algorithms
library(randomForest)
#use only 5 trees
results <- ubRacing(Class ~., ubIonosphere, "randomForest", positive=1, ubConf=ubConf, ntree=5)

# try with 500 trees
# results <- ubRacing(Class ~., ubIonosphere, "randomForest", positive=1, ubConf=ubConf, ntree=500)
# let's try with a different algorithm
# library(e1071)
# results <- ubRacing(Class ~., ubIonosphere, "svm", positive=1, ubConf=ubConf)
# library(rpart)
# results <- ubRacing(Class ~., ubIonosphere, "rpart", positive=1, ubConf=ubConf)
}

\name{ubCNN}
\alias{ubCNN}

\title{Condensed Nearest Neighbor}

\description{Condensed Nearest Neighbor selects the subset of instances that are able to correctly classifing the original datasets using a one-nearest neighbor rule.}

\usage{ubCNN(X, Y, k = 1, verbose = T)}

\arguments{
  \item{X}{the input variables of the unbalanced dataset.}
  \item{Y}{the response variable of the unbalanced dataset. 
  It must be a binary factor where the majority class is coded as 0 and the minority as 1.}
  \item{k}{the number of neighbours to use}
  \item{verbose}{print extra information (TRUE/FALSE)}
}

\details{In order to compute nearest neighbors, only numeric features are allowed.}

\value{
  The function returns a list:
  \item{X}{input variables}
  \item{Y}{response variable}
}
\references{
P. E. Hart. The condensed nearest neighbor rule. IEEE Transactions on Informa- tion Theory, 1968.
}

\seealso{
\code{\link{ubBalance}}
}

\examples{
library(unbalanced)
data(ubIonosphere)
n<-ncol(ubIonosphere)
output<-ubIonosphere$Class
input<-ubIonosphere[ ,-n]

data<-ubCNN(X=input, Y= output)
newData<-cbind(data$X, data$Y)

}
